diff -ur ecryptfs-utils.old/src/utils/mount.ecryptfs_private.c ecryptfs-utils-87/src/utils/mount.ecryptfs_private.c
--- ecryptfs-utils.old/src/utils/mount.ecryptfs_private.c	2011-07-22 21:11:40.897428515 +0000
+++ ecryptfs-utils-87/src/utils/mount.ecryptfs_private.c	2011-07-22 22:21:37.000000000 +0000
@@ -223,7 +223,15 @@
  */
 	FILE *fh;
 	struct mntent m;
-	fh = setmntent("/etc/mtab", "a");
+	struct stat st;
+	const char *filename = "/etc/mtab";
+	if (!lstat(filename, &st) && S_ISLNK(st.st_mode)) {
+		/* Assume that /etc/mtab is a link to /proc/self/mounts, so it should be
+		 * handled automatically.
+		 */
+		return 0;
+	}
+	fh = setmntent(filename, "a");
 	if (fh == NULL) {
 		perror("setmntent");
 		/* Unmount if mtab cannot be updated */
